//Punto Flotante, S.A. El contenido es de
//libre copia y distribucin.
//funciones para el manejo del LCD 16 x 1
//funciones para el teclado matricial 4 x 4
//funcin para inicializar y convertir
//el canal 3 (RA3) del ADC
//libreras para compilador CCS
//maneja leds, microswitches, relevador
//LCD y teclado

#use delay(clock=4000000)	//habilita funcin de delay_ms()

//-------FUNCION CONVERSION ADC, CANAL 3, PIN RA3, 0 A 5 VOLTS.
//REGRESA CON EL VALOR DE LA CONVERSION EN 10 BITS
/*
unsigned long int CANAL3ADC(void)
{
unsigned long int adc;
TRISA=0XF8;
TRISB=0;
ANSEL=8;
ADCON1=0;
ADFM=1;
CHS0=1;
CHS1=1;
CHS2=0;
ADCS0=0;
ADCS1=0;
ADON=1;
CICLO:
GO=1;
ESPERA:
IF(GO_DONE==1)GOTO ESPERA;
adc=ADRESL+(256*ADRESH);
return(adc);
}
*/

//---------------MANEJO DEL LCD-----------------------------

#define eight 		0x38	//comandos del LCD
#define clear 		0x01
#define home  		0x03
#define cursor 		0x0f

//inicializacin variables LCD

void puco(void);	//pulso de escritura

//----FUNCIONES DEL LCD------------------------------------

void initLCD(void)		//INICIALIZA EL LCD
{
	RA1=0;			// prepara escribir comando
	RA2=1;			// pulso de enable normalmente alto
	delay_ms(1);
	PORTB=eight;
	puco();
	PORTB=clear;
	puco();
	PORTB=home;
	puco();
	PORTB=cursor;
	puco();	
}
void clearLCD(void)	//PONE CELDAS EN BLANCO CURSOR EN CELDA (0,0)
{
RA1=0;			// prepara escribir comando
RA2=1;			// pulso de enable normalmente alto
delay_ms(1);
PORTB=clear;		//enva comando clear
puco();				//pulso de escritura
PORTB=cursor;		//habilita cursor
puco();
}

//esta funcion posiciona el cursor en 
//(renglon,columna). 
void cursorXY(int x,int y)
{
RA1=0;				//prepara escribir comando
PORTB=0x02; 
puco();               
delay_us(200);
for(x=x*40+y, y=0; y<x; y++) {
        PORTB = 0x14;
	    puco(); 
		delay_us(200);
}
}

//escribe un caracter en el LCD, en la
//posicin en donde se encuentre el cursor
void putLCD(int c)
{
RA1=1;			//prepara escribir dato
PORTB= c; 
puco(); 		//pulso de escritura
delay_ms(1);
}


void stringLCD(a[])	//escribe string en LCD
{						
int x=0;
while(a[x])			//mientras no sea=0
{PutLCD(a[x]);
x++;
}
}

void puco(void)			//genera pulso de escritura en RA2
{
RA2=0;					//nivel bajo
delay_us(200);
delay_us(200);
RA2=1;					//nivel alto
delay_us(200);
delay_us(200);
}

/*
//inicializacin variables programa teclado------
const char key[16] = {0xEE,0xED,0XEB,0XE7,0XDE,0XDD,0XDB,0XD7,0XBE,0XBD,0XBB,0XB7,0X7E,0X7D,0X7B,0X77};
const char asc[16] = {0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x41,0x42,0x43,0x44,0x45,0x46};
char bot[9];
void fin(void);
void row(void);
unsigned char GetBot(void);
unsigned char aa,bb,cc,dd,ee,ff,xx,yy,zz,boton;

//------FUNCIONES DEL TECLADO----------

unsigned char GetBot(void)			//regresa el caracter ASCII de la tecla oprimida
{

loop:
	ee=0;					
	TRISB=0XF0;
	RBPU=0;					//REGISTRO OPTION, BIT7
							//SELECCIONA RESISTENCIAS DE PULL UP
							//PUERTO B RB0..RB3 SALIDAS, RB4..RB7//
	aa=0xEF;
	PORTB=aa;	
	bb=4;
	while (bb>0) 			//4 corrimientos hacia la derecha//
	{aa=aa/2;
	PORTB=aa;				//ESCRIBE EN PORTB RB0..RB3//
							//LEE PUERTO  RB4..RB7//	
	delay_ms(10);		
	if (RB4==0||RB5==0||RB6==0||RB7==0)fin();
	if (ee==1)return (ff);		//regresa a main con el valor de la tecla en ASCII//
	bb=bb-1;}
	goto loop;

}
void fin(void){			//tecla oprimida//
	
	TRISB=0XF0;
	dd=PORTB;
	cc=(dd & 0XF0);		//bits RB0..RB3 =0, conserva RB4..RB7//
	aa=(aa & 0x0F);		//bits RB4..RB7 =0, conserva RB0..RB3//
	aa=(aa | cc);			//la variable "a" contiene el cdigo rengn columna de la tecla oprimida//

malla:	
	dd=PORTB;			
	cc=(dd & 0XF0);			//bits RB0..RB3 =0, conserva RB4..RB7//
	if(cc!=0xF0)goto malla; 	//espera que la tecla se libere//
	
	TRISB=0;
	row();	
	ff=xx;			//convierte a cdigo ASCII//

	ee=1;
	
}				

 	void row(void)
	{
	
	for(yy=0;yy<16;yy=yy+1)
	{if (aa==key[yy])xx=asc[yy];}	//la variable "x" contiene el valor ASCII//
	PORTB=xx;
	delay_ms(100);
	
}

void SetBot(void)
{
for(zz=0;zz<7;zz++)
{boton=GetBot();
bot[zz]=boton;
if(bot[zz]==0x46)goto qu;
else PutLCD(boton);}
qu:bot[zz]=0x00;

}

void WrtBot(void)
{
for(zz=0;zz<7;zz++)
{putLCD(bot[zz]);
if(bot[zz+1]==0)goto ka;}
ka:zz=zz;				//expresin dummy
}

*/	